



package charite.christo;
import java.awt.*;
import static charite.christo.ChUtils.*;


public final class ChSprite implements Runnable{
private final String _txt;
private final Object _cDest;
private final Font _font=mkFont(12,0);
private final int _w,_h,_xDst,_yDst,_xSrc,_ySrc,_mseconds;
private int _lastX=-0x80000000,_lastY,_x,_y;
public ChSprite(Component cSrc,Point pSrc,Component cDest,Point point,String txt,int mseconds){
_cDest=wref(cDest);
_mseconds=mseconds;
_txt=txt;
if(txt instanceof String){
_h=2*4+charH(_font);
_w=2*4+strgWidth(_font,txt);
}else{
_w=_h=10;
}
_xDst=screenX(cDest)+x(point);
_yDst=screenY(cDest)+y(point);
_xSrc=screenX(cSrc)+x(pSrc);
_ySrc=screenY(cSrc)+y(pSrc);
}



private Object _cPrev;
private Component canvas(){
final Component
cRoot=awtc(25,_cDest),
cDeep=cRoot==null?null: javax.swing.SwingUtilities.getDeepestComponentAt(cRoot,_x,_y),
c=cDeep instanceof Component || cDeep==null?cRoot: cDeep;
if(c==null) return null;
_canvasX=_x-screenX(c);
_canvasY=_y-screenY(c);
if(_cPrev!=(_cPrev=cDeep) && awtc(18|0x200,_cPrev)!=null) _prevX=-0x80000000;
return c;
}



private Image _im,_im2;
private int _offX,_offY,_offW,_offH,_prevX=-0x80000000,_prevY, _canvasX,_canvasY;
private Image offImage(){
final Component c=canvas();
if(c==null) return null;
final int x=_canvasX,dx=_prevX==-0x80000000?0:x-_prevX;
final int y=_canvasY,dy=                  y-_prevY;
if(_prevX==-0x80000000 || _im==null||
x<=_offX || x+_w >=_offX+_offW||
y<=_offY || y+_h>=_offY+_offH){
if(_im==null){
_im=c.createImage(_offW=3*_w,_offH=3*_h);
_im2=c.createImage(_offW,_offH);
}
if(_im==null) return null;
_prevX=x;
_prevY=y;
_offX=x + (dx>0?-4:dx<0?_w-_offW+4:(_w-_offW)/2);
_offY=y + (dy>0?-4:dy<0?_h-_offH+4:(_h-_offH)/2);
final Graphics g=awtGraphics(_im);
g.translate(-_offX,-_offY);
c.paint(g);
g.translate(_offX,_offY);
}
return _im;
}



private void stroke(){
final Component c=canvas();
final Image im=offImage();
final Graphics g=awtGraphics(c),g2=awtGraphics(_im2);
if(g==null||im==null||g2==null) return;
g2.drawImage(im,0,0,c);
final int x=_canvasX-_offX,y=_canvasY-_offY;
if(_txt!=null){
final int ax=_xSrc-_x,ay=_ySrc-_y,transp=32+(int)(2*Math.sqrt(ax*ax+ay*ay));
g2.setColor(argbToColor(0xFFffFF|(transp<<24)));
g2.fillRoundRect(x+1,y+1,_w-2,_h-2,4/2,4/2);
setColorRGB(0,g2);
g2.setFont(_font);
g2.drawString(_txt,x+4,y+4+charA(_font));
}
g.drawImage(_im2,_offX,_offY,c);
}

public void run(){
if(isEDT()) stroke();
else{
final int STEPS=(int)Math.sqrt((_xDst-_xSrc)*(_xDst-_xSrc)+(_yDst-_ySrc)*(_yDst-_ySrc));
for(int i=0;i<STEPS;i++){
_x=(int)(_xSrc+(_xDst-_xSrc)*(float)i/STEPS)-_w/2;
_y=(int)(_ySrc+(_yDst-_ySrc)*(float)i/STEPS)-_h/2;
if(_lastX!=_x || _lastY!=_y || _prevX==-0x80000000){
inEdtLater(this);
_lastX=_x;
_lastY=_y;
}
int delay=_mseconds/STEPS;
if(i<55) delay+=(55-i);
if((STEPS-i)<55) delay+=(55-STEPS+i);
sleepMS(delay);

}
awtc(18|0x600,canvas());
}
}

}

